/*
 *  Face.cpp
 *  HouseOfCards
 *
 *  Created by Carson Baker on 7/15/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#import "Face.h"

Face::Face()
{
	current_frame = 0;
	current_frame_size = 0;
	mode = 2;
	SyncTo(30);
}

void Face::TimerHit(int secs, int thou)
{
	Timed::TimerHit(secs, thou);
//	if(secs > 30) return;
	unsigned int target_frame = (secs * 30) + (int)((thou / 1000.0f) * 30);
	
	if(Timed::isSynced()) {
		loadNextFrame(target_frame);
	}
}

void Face::loadNextFrame(int target_frame)
{
	current_frame++;
	char source[50];
	
	sprintf(source, "../data/%d.csv", target_frame);
	
	if(frame_file) { fclose(frame_file); }
	
	frame_file = fopen(source, "r");
	
	if (frame_file == NULL) 
	{
		CBLog("couldn't open frame file!");
		CBLog("  -- %s", source);
	} else if(current_frame == 2000) {
		current_frame = 0;
		
		return;
	}
	
	const char delims[] = ",";
	char line[255];
	int counter = 0;
	
	if(frame_file != NULL) {
		while(fgets(line, 255, frame_file) != NULL)
		{
			char *first;
			char *second;
			char *third;
			char *fourth;
			
			first	= strtok( line, delims );
			second	= strtok( NULL, delims);
			third	= strtok( NULL, delims);
			fourth	= strtok( NULL, delims);
			
			dots[counter].set(atof(first),atof(second),atof(third),atof(fourth));
			
			counter++;
		}
	}
	
	current_frame_size = counter;
}

void Face::Draw()
{
	bool lstrip = false;
	
	glScalef(1,-1,-1);
	glScalef(0.1,0.1,0.1);
	glTranslatef(-100,-150,100);
	glRotatef(90,0,1,0);
	
	GLenum how;
	
	switch(mode) {
		case 0: how = GL_POINTS; break;
		case 1: how = GL_LINES; break;
		case 2: how = GL_LINE_STRIP; break;
		case 3: how = GL_QUAD_STRIP; break;
		default: how = GL_LINES;
	}
	
	glPointSize(2.0f);
	glBegin(how);
	float factor = 0;
	
	for(int i = 0; i < current_frame_size; i++) {
		
		if((dots[i][3] < 25) && (dots[i].distanceSquared(dots[i-1]) > 300)) {
			
			glEnd();
			glBegin(GL_POINTS);
			lstrip = true;
			factor = dots[i][3] / 200.0f;
			
		} else if((lstrip == true)) {
			glEnd();
			lstrip = false;
			glBegin(how);
			
			factor = dots[i][3] / 155.0f;
		} else {
			
			factor = dots[i][3] / 155.0f;
		}
		
		glColor3f(0.1f * factor * 10 , 0.3f * factor, 1.0f * factor * 2); // light green
		
		glVertex3fv(dots[i].vec);
		if(how == GL_QUAD_STRIP) {
			glVertex3f(dots[i][0]-1.0, dots[i][1], dots[i][2]);
		}
		
		
	}
	
	glEnd();
	
	
}
